#include <stdio.h>
#include <pthread.h>

typedef struct {
  volatile int toy_shared;
  pthread_mutex_t mutex_for_toy;
} mydata;

void *mystart(void *arg)
{
  mydata *p = arg;
  for (int i = 0; i < 1000000; i++) {
    pthread_mutex_lock(&p->mutex_for_toy);
    p->toy_shared++;
    pthread_mutex_unlock(&p->mutex_for_toy);
  }
  return NULL;
}

int main(void)
{
  pthread_t t1, t2;
  mydata shared;

  shared.toy_shared = 0;
  pthread_mutex_init(&shared.mutex_for_toy, NULL);

  pthread_create(&t1, NULL, mystart, &shared);
  pthread_create(&t2, NULL, mystart, &shared);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

  printf("final count: %d\n", shared.toy_shared);

  pthread_mutex_destroy(&shared.mutex_for_toy);

  return 0;
}
