#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

typedef struct mythreadarg {
  unsigned n;                       // how many iterations to loop
  unsigned s;                       // sleep time
  char *msg;                        // message to print
} mythreadarg;

// This example shows how to return a value and how to receive it. I want to
// returned a number. But the API makes me return a pointer. To make this
// example generalizable, I malloc space for holding the return value; the
// receiver will have to remember to free it :(

void* mythreadstart(void *arg)
{
  mythreadarg *p = arg;
  for (unsigned i = 0; i < p->n; i++) {
    sleep(p->s);
    printf("%s\n", p->msg);
  }
  unsigned *r = malloc(sizeof(unsigned));
  *r = p->n * p->s;
  return r;
}

int main(void)
{
  pthread_t t1, t2;

  mythreadarg a1 = { 5, 2, "hello" };
  mythreadarg a2 = { 4, 3, "hi" };

  pthread_create(&t1, NULL, mythreadstart, &a1);
  pthread_create(&t2, NULL, mythreadstart, &a2);

  unsigned *p;
  pthread_join(t1, (void**) &p);
  printf("1st thread returns %u\n", *p);
  free(p);
  pthread_join(t2, (void**) &p);
  printf("2nd thread returns %u\n", *p);
  free(p);

  return 0;
}
