#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

typedef struct mythreadarg {
  unsigned n;                       // how many iterations to loop
  unsigned s;                       // sleep time
  char *msg;                        // message to print
} mythreadarg;

void* mythreadstart(void *arg)
{
  mythreadarg *p = arg;
  for (unsigned i = 0; i < p->n; i++) {
    sleep(p->s);
    printf("%s\n", p->msg);
  }
  return NULL;
}

int main(void)
{
  pthread_t t1, t2;

  mythreadarg a1 = { 5, 2, "hello" };
  mythreadarg a2 = { 4, 3, "hi" };

  pthread_create(&t1, NULL, mythreadstart, &a1);
  pthread_create(&t2, NULL, mythreadstart, &a2);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

  // Exercise: What if main thread doesn't wait for t1, t2, but instead calls
  // pthread_exit?

  return 0;
}
